/**
 * NORRIS.js
 * Copyright (c) 2011 Ruben L Z Tan
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */
'use strict'

var fs      = null;
var path    = null;

/**----------------------------------------------------------------------------
 * Factory module definition
 */
var Factory = module.exports = {
    // Properties
    norris  : null,
    
    // Methods
    make    : make,
    add     : add,
    load    : load
};

/**----------------------------------------------------------------------------
 * Creates a factory with the proper dependencies
 */
function make(deps) {
    if (undefined === deps.norris)
        throw new Error('NORRIS namespace needed');
    if (undefined === deps.fs)
        throw new Error('Fs module needed (node.fs)');
    if (undefined === deps.path)
        throw new Error('Path module needed (node.path)');
        
    fs          = deps.fs;
    path        = deps.path;
    this.norris = deps.norris;
    
    return this;
}

/**----------------------------------------------------------------------------
 * Initializes the NORRIS namespace
 * 
 * pocket   = the first level namespace after norris to attach to
 * basepath = the base path of the directory to convert into a namespace 
 */
function add(pocket, basepath) {
    
    
    
    return this.norris;
}

/**----------------------------------------------------------------------------
 * Loads a module
 */
function load(ns) {
    var tokens = ns.split('.');
}
